Alipay+ DocsAlipay+ Docs

notifyPayment (NFC Payment)MPP Alipay+

POST /aps/api/v1/payments/notifyPayment

The notifyPayment API allows the Mobile Payment Provider (MPP) to notify the payment result to Alipay+ when payment processing reaches a final state of success or failure.

Note: In the following sections, Mobile Payment Provider (MPP) is also known as Payment Service Provider (PSP). For example, the pspId parameter specifies the ID that identifies an MPP. 

Structure

A message consists of a header and body. The following sections are focused on the body structure. For the header structure, see:

Note: 

1. Set the data type of each parameter (except array) as String. This means that you must use double quotation marks (" ") to enclose the parameter value. Examples:

  • If the data type of a parameter is Integer and its value is 20, set it as "20".
  • If the data type of a parameter is Boolean and its value is true, set it as "true".  

2. For optional parameters that are not required in your case, you can take one of the following actions:

  • Exclude the parameters from the request body.
  • Set the parameter values as null (without the double quotation marks). 

Do NOT leave the optional parameters empty by setting their values as ""; otherwise, an error might occur.  

Request parameters

paymentResult Result  REQUIRED

The result of the payment. The value of the paymentResult.resultStatus parameter represents the payment status, where S represents success and F represents failure. The value of the paymentResult.resultStatus parameter cannot be U when this API is called to send the payment result. See the Payment result codes table for more details.  

Show child parameters

paymentRequestId String  REQUIRED

The unique ID that is assigned by Alipay+ to identify a payment order.  

More information:

  • This field is an API idempotency field. Alipay+ regards the notifications with the same paymentRequestId as repeated and processes them only once. Alipay+ checks the consistency of the following key request parameters: paymentAmount, paymentResult, paymentId, payToAmount, and customerId. If any values differ from the previous notification, Alipay+ returns the REPEAT_REQ_INCONSISTENT result code.
  • Maximum length: 64 characters

paymentId String  

The unique ID that is assigned by the MPP to identify a payment order.

Specify this parameter if the value of the paymentResult.resultStatus parameter is S, which means that the payment succeeds. 

More information:

  • Maximum length: 64 characters

paymentAmount Amount  REQUIRED

The amount that Alipay+ requests to receive from the MPP. The currency of this amount must be the same as that used by Alipay+ to create the payment order. If a promotion exists, this amount does not include the promotion amount.

Specify this parameter if the value of the paymentResult.resultStatus parameter is S, which means that the payment succeeds. 

Show child parameters

payToAmount Amount  

The amount that the MPP settles to Alipay+. The currency of the amount is the MPP's currency.

Specify this parameter if the value of the paymentResult.resultStatus parameter is S and payToAmount.currency is different from paymentAmount.currency. When this parameter is specified, payToAmount.value is calculated based on paymentAmount.value and paymentQuote.quotePrice by using the rounding mode of HALF EVEN. 

Show child parameters

paymentTime Datetime  

The date and time when the payment order reaches a final state.

Specify this parameter if the value of the paymentResult.resultStatus parameter is S, which means that the payment succeeds. 

Show child parameters

customerId String  

The unique ID that is assigned by the MPP to identify a user.

Specify this parameter if the value of the paymentResult.resultStatus parameter is S, which means that the payment succeeds. 

More information:

  • Maximum length: 64 characters

passThroughInfo String  

The information that is passed through by the MPP to Alipay+. The value of this parameter is in a set of key-value pairs. 

Specify this parameter if the MPP wants to pass information to the ACQP. 

More information:

  • Maximum length: 20000 characters

Response parameters

result Result  REQUIRED

The result of the business processing, including the result status, result code, and result message. For more information about how to handle the result of notifyPayment API, see How to handle the result

Show child parameters

acquirerId String  

The unique ID that is assigned by Alipay+ to identify an ACQP.

This parameter is returned by Alipay+ if the value of the result.resultCode parameter is SUCCESS, which means that the notification succeeds. 

More information:

  • Maximum length: 64 characters

pspId String  

The unique ID that is assigned by Alipay+ to identify an MPP. 

This parameter is returned by Alipay+ if the value of the result.resultCode parameter is SUCCESS, which means that the notification succeeds. 

More information:

  • Maximum length: 64 characters
API Explorer
Sample CodesRun in Sandbox

Request

URL
Method
POST
Request Body

Response

Response Body

More information

How to handle the result

You might receive different results from Alipay+. Follow the instructions below to handle the result. 

result.resultStatus

result.resultCode

Notification status

Actions

S

SUCCESS

Successful

N/A

F

Multiple possible values exist, such as ACCESS_DENIED, KEY_NOT_FOUND, etc.

Failed

Take action based on the result code (specified in result.resultCode ). For more information, see the Result codes section below.

U

Multiple possible values exist, such as UNKNOWN_EXCEPTION, REQUEST_TRAFFIC_EXCEED_LIMIT, etc.

Unknown

Retry the request.

No result received


Unknown

Retry the request.


Result/Error codes

CodeValueMessageFurther action
SUCCESSSSuccess

N/A 

ACCESS_DENIEDFAccess is denied.

Contact connect_support@service.alipay.com to troubleshoot the issue. 

INVALID_CLIENTFThe client is invalid.

Contact connect_support@service.alipay.com to troubleshoot the issue. 

INVALID_SIGNATUREFThe signature is invalid.

Check whether the public key, signed message, and signature algorithm are as expected. 

KEY_NOT_FOUNDFThe key is not found.

Contact connect_support@service.alipay.com to troubleshoot the issue. 

MEDIA_TYPE_NOT_ACCEPTABLEFThe server does not implement the media type that is acceptable to the client.

Use a media type that is accepted by Alipay+

METHOD_NOT_SUPPORTEDFThe server does not implement the requested HTTPS method.

Ensure the HTTP method is POST. 

NO_INTERFACE_DEFFAPI is not defined.

Check whether the request URL is correct. Ensure that the endpoint of the called API is correct. 

PARAM_ILLEGALFIllegal parameters. For example, non-numeric input, invalid date.

Check that all request parameters, including header and body parameters, are valid. For more information, see the Structure section of the specific API reference topic.

PROCESS_FAILFA general business failure occurred. Do not retry.

Contact connect_support@service.alipay.com to troubleshoot the issue. 

REQUEST_TRAFFIC_EXCEED_LIMITUThe request traffic exceeds the limit.

Reduce the frequency of API calls. 

UNKNOWN_EXCEPTIONUAn API call failed, which is caused by unknown reasons.

Try to recall the API. 

Payment result codes

CodeValueMessage
SUCCESSSSuccess
BUSINESS_NOT_SUPPORTFThe payment business is not supported.
CURRENCY_NOT_SUPPORTFThe currency is not supported.
EXPIRED_CODEFThe code is expired.
INVALID_CONTRACTFThe contract is invalid.
INVALID_TOKENFThe access token is invalid.
MERCHANT_NOT_REGISTEREDFThe merchant is not registered.
ORDER_IS_CLOSEDFThe order is closed.
PAYMENT_AMOUNT_EXCEED_LIMITFThe payment amount exceeds the limit that is specified by Alipay+.
PAYMENT_COUNT_EXCEED_LIMITFThe number of payments exceeds the limit.
PROCESS_FAILFA general business failure occurred. Do not retry.
REGULATION_RESTRICTIONFThe payment failed due to regulatory restriction.
RISK_REJECTFThe request is rejected because of the risk control.
UNAVAILABLE_PAYMENT_METHODFThe payment method is unavailable.
USER_AMOUNT_EXCEED_LIMITFThe payment amount exceeds the payment limit that is specified by the user's digital wallet.
USER_BALANCE_NOT_ENOUGHFThe user balance is not enough for the payment.
USER_NOT_EXISTFThe user does not exist.
USER_PAYMENT_VERIFICATION_FAILEDFUser fails to pass the payment verification in the methods like OPT, PIN, and so on.
USER_STATUS_ABNORMALFThe user status is abnormal.